<?php
/*
Plugin Name: HeadLine Essence
Plugin URI: 
Description: 記事に目次を追加
Version: 1.1.0
Author:Healing Solutions
Author URI: https://www.healing-solutions.jp/
License: GPL2
*/

/*  Copyright 2016 Healing Solutions (email : info@healing-solutions.jp)
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
     published by the Free Software Foundation.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//プラグインのパスを設定

	//本文からheadline_navクラスをリストアップ


	add_filter( 'the_content','go_index_essence',10);
	function go_index_essence( $content ) {

		if(is_singular()){

			$h2_list = array();
			preg_match_all('/<h1(.+)?>(.+)<\/h1>/u', $content, $h2_list);
		

			//置換・目次の準備
			list($h2_outer,$before,$h2_inner) = $h2_list;

			$search = $h2_outer;
			$replace = array();
			$li_list = array();

			if(!empty($h2_inner)){


				foreach ($h2_inner as $key => $val) {
						$replace[] = sprintf('<div id="link%s" class="ancor"><h1'.$before[0].'>%s</h1></div>', $key, $val);
						$li_list[] = sprintf('<li><a href="#link%s">%s</a></li>', $key, $val);
				}


				$word = mb_strlen(strip_tags($content));
				$m = floor($word / 600)+1;
				$time = ($m == 0 ? '' : $m) ;

				//目次部分
				$index_nav = null;
				$index_nav .= '<div class="index-nav-block clearfix">
											<div class="menu_bkg menu_color can-toggle">目次</div>
											<div class="index-nav-inner bdr-1">
													この記事にはこんなことが書かれています';

				 $index_nav .= '<ol>' .  implode("\n", $li_list) .'</ol>';
				 $index_nav .= $word.'文字なので、およそ'.$time.'分で読み終わりそうです
				 </div>
				</div>
				';
				//リンク用のidを埋め込んだ本文


				$content = str_replace($search, $replace, $content);
				$content = $index_nav . $content;
			};
		}
			
			return $content;
	}
	
